/*
** Copyright (C) 2006 Thadeu Lima de Souza Cascardo <cascardo@minaslivre.org>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef NET_HOOK_H
#define NET_HOOK_H

#include <glib.h>
#include "hcconn.h"

typedef struct _net_hook_t net_hook_t;
typedef void (*net_connect) (net_hook_t*);
typedef void (*net_close) (net_hook_t*);
typedef void (*net_write) (net_hook_t*);
typedef void (*net_read) (net_hook_t*, gchar*, size_t);

struct _net_hook_t
{
  HCConn* conn;
  net_hook_t* peer;
  gboolean server;
  net_connect connect;
  net_close close;
  net_read read;
  gpointer data;
};

void nethook_event (HCConn*, HCEvent, gpointer);

#endif
